<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "network".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Network".
 *
 * Columns in table "network" available as properties of the model,
 * followed by relations of table "network" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property integer $core_only
 * @property integer $wisconsin_only
 * @property integer $national_ppo
 * @property integer $mercy
 * @property integer $medical_service
 * @property integer $chiropractic_service
 * @property integer $mental_healther_service
 * @property integer $home_health_service
 * @property integer $oral_surgery_service
 * @property integer $vision_service
 * @property integer $ambulance_service
 * @property integer $quality_path
 *
 * @property Employer[] $employers
 */
abstract class BaseNetwork extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'network';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Network|Networks', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('core_only, wisconsin_only, national_ppo, mercy, medical_service, chiropractic_service, '
                . 'mental_healther_service, home_health_service, oral_surgery_service, vision_service, '
                . 'ambulance_service, quality_path', 'numerical', 'integerOnly' => true),
            array('name', 'length', 'max' => 50),
            array('name, core_only, wisconsin_only, national_ppo, mercy, medical_service, chiropractic_service,'
                . ' mental_healther_service, home_health_service, oral_surgery_service, vision_service, '
                . 'ambulance_service, quality_path', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, core_only, wisconsin_only, national_ppo, mercy, medical_service, chiropractic_service,'
                . ' mental_healther_service, home_health_service, oral_surgery_service, vision_service, '
                . 'ambulance_service, quality_path', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'employers' => array(self::HAS_MANY, 'Employer', 'network_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'core_only' => Yii::t('app', 'Core Only'),
            'wisconsin_only' => Yii::t('app', 'Wisconsin Only'),
            'national_ppo' => Yii::t('app', 'National Ppo'),
            'mercy' => Yii::t('app', 'Mercy'),
            'medical_service' => Yii::t('app', 'Medical Service'),
            'chiropractic_service' => Yii::t('app', 'Chiropractic Service'),
            'mental_healther_service' => Yii::t('app', 'Mental Healther Service'),
            'home_health_service' => Yii::t('app', 'Home Health Service'),
            'oral_surgery_service' => Yii::t('app', 'Oral Surgery Service'),
            'vision_service' => Yii::t('app', 'Vision Service'),
            'ambulance_service' => Yii::t('app', 'Ambulance Service'),
            'quality_path' => Yii::t('app', 'Quality Path'),
            'employers' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('core_only', $this->core_only);
        $criteria->compare('wisconsin_only', $this->wisconsin_only);
        $criteria->compare('national_ppo', $this->national_ppo);
        $criteria->compare('mercy', $this->mercy);
        $criteria->compare('medical_service', $this->medical_service);
        $criteria->compare('chiropractic_service', $this->chiropractic_service);
        $criteria->compare('mental_healther_service', $this->mental_healther_service);
        $criteria->compare('home_health_service', $this->home_health_service);
        $criteria->compare('oral_surgery_service', $this->oral_surgery_service);
        $criteria->compare('vision_service', $this->vision_service);
        $criteria->compare('ambulance_service', $this->ambulance_service);
        $criteria->compare('quality_path', $this->quality_path);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
